#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "common1.h"
#include "common3.h"

  void read_row(FILE *,double *,int);
  void rdcl_row(FILE *,double *,double *);

  void init_param()
{ FILE *fp;
  int i,j;

  sint=sizeof(int);
  spd1=sizeof(double *);
  spd2=sizeof(double **);
  spd3=sizeof(double ***);
  spi1=sizeof(int *);
  spi2=sizeof(int **);
  spm1=sizeof(struct mat *);
  spm2=sizeof(struct mat **);


/**********************************
    system.dat
**********************************/

  fp=fopen("system.dat","r");
  while(getc(fp)!=':');
  fscanf(fp," %d\n",&jc1);
  jc2=m_iarr1(jc1);
  jc3=(int **) malloc(jc1*spi1);
  for(i=0;i<jc1;i++) {
    while(getc(fp)!=':');
    fscanf(fp," %d\n",&jc2[i]);
    jc3[i]=m_iarr1(jc2[i]);
    for(j=0;j<jc2[i];j++) {
      while(getc(fp)!=':');
      fscanf(fp," %d\n",&jc3[i][j]);
    }
  }
  while(getc(fp)!=':');
  fscanf(fp," %d\n",&ir1);
  ir2=m_iarr1(ir1);
  ir3=(int **) malloc(ir1*spi1);
  for(i=0;i<ir1;i++) {
    while(getc(fp)!=':');
    fscanf(fp," %d\n",&ir2[i]);
    ir3[i]=m_iarr1(ir2[i]);
    for(j=0;j<ir2[i];j++) {
      while(getc(fp)!=':');
      fscanf(fp," %d\n",&ir3[i][j]);
    }
  }
  fclose(fp);

  N_BLKM=16;
  N_SCEM=4;
  N_PLNT=jc3[8][0]+jc3[8][1]+3;
  N_EPLNT=jc3[8][0];
  N_CPLNT=jc3[8][1]+3;
  N_FUEL=7;
  N_FOS=3;
/*  N_REN=jc2[3];*/

  N_REN=4;
  N_DEM=4;
  N_EGRADE=jc3[2][0];
  N_RGRADE=5;
  N_DCO2=jc3[2][4];
  N_REFO=jc3[2][5];
  LR=10;
  N_TIME=8;
  IINTER=jc2[0];
  ITRANS=jc2[1];
  start_yr=2000.;

  co2tax=m_darr3(LR,N_SCEM,N_TIME);
  co2reg=m_darr3(LR,N_SCEM,N_TIME);
  co2con=m_darr2(N_SCEM,N_TIME);
  temper=m_darr2(N_SCEM,N_TIME);
  co2tran=m_darr3(LR,2,N_TIME);
  prob_s=m_darr1(N_SCEM);
  prob_k=m_darr1(N_BLKM);
  co2emi=m_darr2(4,N_TIME+1);
  tsoxemi=m_darr2(4,N_TIME+1);
  soxemi=m_darr3(4,LR,N_TIME+1);
  sulreg=m_darr3(LR,N_SCEM,N_TIME);
  sultax=m_darr3(LR,N_SCEM,N_TIME);

  co2cef=m_darr1(N_FUEL);
  shfdsk=m_darr2(LR,N_FOS);
  reoils=m_darr1(LR);
  dulfel=m_darr2(LR,3);
  parele=m_darr2(LR,7);
  tdloss=m_darr3(LR,7,N_TIME);
  nclurt=m_darr2(LR,N_TIME);
  trnlos=m_darr2(4,N_TIME);
  elcoef=m_darr2(N_EPLNT,N_TIME);
  chcoef=m_darr3(N_CPLNT,3,N_TIME);
  relaef=m_darr3(3,LR,N_TIME);
  co2ene=m_darr3(3,2,N_TIME);
  co2sub=m_darr1(2);
  upplmt=m_darr1(N_FOS);
  lowlmt=m_darr1((N_FOS+N_REN));
  deprrt=m_darr2(2,10);
  ect_2000=m_darr1(N_EPLNT);
  rel_2000=m_darr2(3,LR);
  trcost=m_darr2(10,3);
  plcost=m_darr2(N_PLNT,5);
  rlcost=m_darr3(10,LR,N_TIME);
  co2cap=m_darr2(LR,N_DCO2-2);
  co2cst=m_darr2(LR,N_DCO2);
  egrade=m_darr3(LR,N_FOS,N_EGRADE);
  epcost=m_darr2(N_FOS,N_EGRADE);
  rco2cef=m_darr2(N_FOS,N_EGRADE);
  rgrade=m_darr3(LR,N_REN,N_RGRADE+1);
  rpcost=m_darr3(LR,N_REN,N_RGRADE+1);
  acrdrt=m_darr2(N_REN,N_TIME);
  nclrct=m_darr1(N_TIME);
  refore=m_darr2(LR,2+N_REFO*2);
  rgdk=m_darr3(LR,N_REN-1,5);

  sulcef=m_darr1(2);
  desulc=m_darr2(5,2);
  desuld=m_darr1(3);

  discnt=m_darr1(N_TIME);
  dis_f=m_darr1(N_TIME);
  dis_p=m_darr1(N_TIME);
  dis_inv=m_darr2(LR,N_TIME);

  dis_i1=m_darr2(LR,N_TIME);
  dis_i2=m_darr2(LR,N_TIME);
  dis_i3=m_darr2(LR,N_TIME);

  demand=m_darr3(LR,4,N_TIME);
  scnucl=m_darr2(LR,N_TIME);
  misncl=m_darr2(LR,N_TIME);
  oilsha=m_darr3(LR,3,N_TIME);
  ele_min=m_darr3(LR,4,N_TIME);
  pop0=m_darr2(LR,N_TIME);
  gdp0=m_darr2(LR,N_TIME);
  ivs0=m_darr2(LR,N_TIME);
  kap0=m_darr2(LR,N_TIME);
  inv0=m_darr2(LR,N_TIME);
  kap_up=m_darr2(LR,N_TIME);
  kap_low=m_darr2(LR,N_TIME);
  rkap=m_darr2(LR,N_BLKM);
  kapk=m_darr2(LR,N_BLKM);
  mepm=m_darr2(LR,6);
  klelas=m_darr1(LR);
  enelas=m_darr1(LR);
  prod_a=m_darr2(LR,N_BLKM);
  prod_b=m_darr3(LR,N_DEM,N_BLKM);
  prod_c=m_darr2(LR,N_BLKM);
  gdp_2000=m_darr1(LR);
  kap_2000=m_darr1(LR);
  ivs_2000=m_darr1(LR);
  dem_2000=m_darr2(LR,4);
  cem_2000=m_darr1(LR+6);
  oilgenplt_max=m_darr2(LR,N_TIME);
  sh_new_t=m_darr2(LR,N_TIME);

  tariff=m_darr3(LR,5,N_TIME);
  subsid=m_darr3(LR,7,N_TIME);
  royalt=m_darr3(LR,3,N_TIME);
  profit=m_darr3(LR,5,N_TIME);

  trland=m_darr2(LR,LR);
  trocea=m_darr2(LR,LR);
  trnco2=m_darr2(LR,3);

  cexist=m_darr3(LR,7,2);
  gepatn=m_darr3(LR,4,3);
  prtrad=m_darr2(LR,3);
  currpr=m_darr2(LR,5);
  ele_2000=m_darr2(LR,4);

  landarea=m_darr2(LR,N_TIME);
  bio_productivity=m_darr3(LR,2,N_TIME);
  bio_potential=m_darr3(LR,12,N_TIME);
  bio_share=m_darr2(LR,24);
  bio_cost=m_darr2(LR,24);

  enepri=m_darr2(LR,N_DEM);
  elast=m_darr2(LR,N_DEM);
  enepot=m_darr2(LR,N_TIME);
  dispri=m_darr3(LR,N_DEM,N_TIME);
  prelas=m_darr2(LR+1,N_DEM);
  shdpri=m_darr3(LR,N_DEM,N_TIME);
  enecon_f=m_darr3(LR+1,N_DEM,N_BLKM);
  slope_f=m_darr4(LR+1,N_REN-1,N_RGRADE,N_BLKM);
  slope_df=m_darr4(LR+1,N_REN-1,N_RGRADE,N_BLKM);



  n_tm=m_iarr1(N_BLKM);
  n_sc=m_iarr2(N_SCEM,N_BLKM);
  inc_mat=m_iarr2(2,N_BLKM);
}


  void init_num()
{ int i,j,k,k0,n,myr;
  double *d1,*d2,*d3,*d4,dd,v,s1,s2;

/* Conversion Coefficient from TOE to MWh */
  etcon=11.628;

/* reciprocal number of the total hours in a year */
  rpyt=1./8.76;

  d1=m_darr1(N_TIME);
  d2=m_darr1(N_TIME);
  d3=m_darr1(N_TIME);
  d4=m_darr1(N_TIME);


  n_yr=m_darr1(N_TIME);
  rpck=m_darr4(LR,N_REN-1,6,N_BLK);
  cdemak=m_darr3(LR,N_DEM,N_BLK);
  rdemak=m_darr3(LR,N_DEM,N_BLK);
  damage=m_darr2(LR,N_BLK);
  f_off_set=m_darr1(LR);

  jc=(int ****) malloc(jc1*sizeof(int ***));
  for(i=0;i<jc1;i++) {
    jc[i]=(int ***) malloc(jc2[i]*spi2);
    for(j=0;j<jc2[i];j++) {
      jc[i][j]=m_iarr2(jc3[i][j],N_BLK);
    }
  }

  ir=(int ****) malloc(ir1*sizeof(int ***));
  for(i=0;i<1;i++) {
    ir[i]=(int ***) malloc(ir2[i]*spi2);
    for(j=0;j<ir2[i];j++) {
      ir[i][j]=m_iarr2(ir3[i][j],N_SCE);
    }
  }
  for(i=1;i<ir1;i++) {
    ir[i]=(int ***) malloc(ir2[i]*spi2);
    for(j=0;j<ir2[i];j++) {
      ir[i][j]=m_iarr2(ir3[i][j],N_BLK);
    }
  }

  n_yr[0]=2010.; n_yr[1]=2020.; n_yr[2]=2030.; n_yr[3]=2040.;
  n_yr[4]=2050.; n_yr[5]=2075.; n_yr[6]=2100.; n_yr[7]=2150.;

  for(i=1;i<N_TIME;i++) {
    d1[i]=0.;
    d2[i]=0.;
    d3[i]=0.;
    d4[i]=0.;
  }
  
  d1[0]=(n_yr[0]-start_yr)*discnt[0];
  for(i=1;i<N_TMP;i++)
    d1[i]=(n_yr[i]-n_yr[i-1])*discnt[i];
  dd=1.;
  for(i=0;i<N_TMP;i++) {
    d2[i]=exp(-d1[i]);
    d3[i]=dd*(1.-d2[i])/discnt[i];
    d4[i]=dd*(1.-d2[i]*(1.+d1[i]))/d1[i]/discnt[i];
    dd*=d2[i];
  }

  for(i=0;i<N_TMP-1;i++)
    dis_f[i]=d4[i]+d3[i+1]-d4[i+1];
  dis_f[N_TMP-1]=d4[N_TMP-1];

  for(i=0;i<3;i++)
    dis_p[i]=d4[i]+d3[i+1]+d3[i+2]+d3[i+3]-d4[i+3];
  dis_p[3]=d4[3]+d3[4]+d3[5]-d4[5];
  dis_p[4]=d4[4]+d3[5]-d4[5];
  dis_p[5]=dis_f[5];
  dis_p[6]=dis_f[6];
  dis_p[7]=dis_f[7];

  for(n=0;n<LR;n++) {
    d1[0]=(n_yr[0]-start_yr)*mepm[n][0];
    for(i=1;i<N_TIME;i++)
      d1[i]=(n_yr[i]-n_yr[i-1])*mepm[n][0];
    for(i=0;i<N_TIME;i++) {
      d2[i]=exp(-d1[i]);
      dis_i1[n][i]=(1.-d2[i]*(1.+d1[i]))/d1[i]/mepm[n][0];
      dis_i2[n][i]=(d1[i]-1.+d2[i])/d1[i]/mepm[n][0];
      dis_i3[n][i]=d2[i];
    }
  
  s1=1000.*dis_f[N_TMP-1]/dis_i2[n][N_TMP-1];
  dis_inv[n][N_TMP-1]=dis_f[N_TMP-1];
    for(i=N_TMP-2;i>=0;i--) {
     s2=1000.*(mepm[n][0]+discnt[i])*dis_f[i]+dis_i3[n][i+1]*s1;
       dis_inv[n][i]=(dis_i1[n][i+1]*s1+dis_i2[n][i]*s2)/1000.;
     s1=s2;
  }
  }


  JC=0;
  IR=0;

 /* Numbering for variables */

  for(k=0;k<N_BLK;k++) {

    for(i=0;i<8;i++) 
      for(j=0;j<jc2[i];j++)
        for(n=0;n<jc3[i][j];n++)
          jc[i][j][n][k]=JC++;

    k0=-1;
    for(i=0;i<k;i++)
      if(inc_mat[0][k]==inc_mat[0][i])  k0=i;
    if(k>5||k0==-1) {
      for(j=0;j<jc2[8];j++)
        for(n=0;n<jc3[8][j];n++)
          jc[8][j][n][k]=JC++;
    }
    else {
      for(j=0;j<jc2[8];j++)
        for(n=0;n<jc3[8][j];n++)
          jc[8][j][n][k]=jc[8][j][n][k0];
    }

    for(i=0;i<3;i++) {
      jc[9][0][i][k]=jc[5][0][i][k];
      jc[9][1][i][k]=jc[5][1][i][k];
      jc[9][2][i][k]=jc[5][2][i][k];
      jc[9][3][i][k]=jc[5][3][i][k];
      jc[9][4][i][k]=jc[5][3][i+3][k];
      jc[9][5][i][k]=jc[5][4][i][k];
      jc[9][6][i][k]=jc[5][5][i][k];
      jc[9][8][i][k]=jc[5][7][i][k];
   }
    jc[9][7][0][k]=jc[5][0][3][k];
    jc[9][7][1][k]=jc[5][1][4][k];
    jc[9][7][2][k]=jc[5][2][3][k];
    jc[9][7][3][k]=jc[5][2][4][k];
    jc[9][7][4][k]=jc[5][2][5][k];
    jc[9][7][5][k]=jc[5][3][8][k];
    jc[9][7][6][k]=jc[5][4][5][k];
    jc[9][7][7][k]=jc[5][5][3][k];
    jc[9][7][8][k]=jc[5][5][4][k];
    jc[9][7][9][k]=jc[5][5][5][k];
    jc[9][7][10][k]=jc[5][7][3][k];
    jc[9][7][11][k]=jc[5][7][4][k];
    jc[9][7][12][k]=jc[5][7][5][k];
  }


 /* Numbering for constraints */

  for(k=0;k<N_SCE;k++)
    for(i=0;i<1;i++) 
      for(j=0;j<ir2[i];j++)
        for(n=0;n<ir3[i][j];n++) ir[i][j][n][k]=IR++;

  for(k=0;k<N_BLK;k++) 
    for(i=1;i<ir1;i++) 
      for(j=0;j<ir2[i];j++)
        for(n=0;n<ir3[i][j];n++) ir[i][j][n][k]=IR++;

  islack=m_iarr1(IR);
  for(i=0;i<IR;i++)  islack[i]=1;
  for(k=0;k<N_BLK;k++) {
    islack[ir[1][0][6][k]]=0;
    islack[ir[1][0][12][k]]=0;
    islack[ir[6][0][3][k]]=0;
    for(i=0;i<3;i++) {
      islack[ir[1][1][i][k]]=0;
      islack[ir[2][1][i][k]]=0;
    }
  }

  KEL=(IINTER*LR+ITRANS+LR+1);
  KE=KEL*N_BLK;

  kslack=m_iarr1(KE);
  for(i=0;i<KE;i++) kslack[i]=0;
  for(i=0;i<N_BLK;i++) kslack[KEL*i+IINTER*LR+ITRANS+LR]=1;

  printf("\n");
  printf("  The number of variables   : %5d for regional opt.\n",JC);
  printf("  The number of constraints : %5d for regional opt.\n",IR);
  printf("  The number of variables   : %5d for global   opt.\n",LR*JC+KE);
  printf("  The number of constraints : %5d for global   opt.\n",KE);
  printf("\n");

  i=0;
  JP_OIL_DI=i++;     /* Oil Refinery Distillation */
  JP_OIL_GA=i++;     /* Oil Refinery Gasoline Production */
  JP_NGAS_C=i++;     /* Natural Gas Splitting */
  JP_COAL_G=i++;     /* Coal Gasification */
  JP_COAL_L=i++;     /* Coal Liquefaction */
  JP_BIOM_G=i++;     /* Biomass Gasification */
  JP_BIOM_L=i++;     /* Biomass Liquefaction */
  JP_CH4_SY=i++;     /* CH4 Synthesis */
  JP_MEOH_S=i++;     /* CH3OH Synthesis from CO */
  JP_MEOH_D=i++;     /* CH3OH Synthesis from CO2 */
  JP_SHIFT =i++;     /* Shift Reactor Conversion Process */
  JP_MEOH_U=i++;     /* Up-grading of Methanol to Gasoline */
  JP_W_ELEC=i++;     /* Water Electrolysis */
  JP_CO2R_C=i++;     /* CO2 Recovery from Flue Gas */
  JP_CO2R_P=i++;     /* CO2 Recovery from Shifted Fuel Gas */
  JP_H2_LIQ=i++;     /* H2  Liquefaction */
  JP_C4_LIQ=i++;     /* CH4 Liquefaction */
  JP_C2_LIQ=i++;     /* CO2 Liquefaction */
  JP_BIOM_GA=i++;    /* Biomass Gasification(Anaerobiotic Digestion) */
  JP_BIOM_LF=i++;    /* Biomass Liquefaction(Fermentation)*/

  if(i!=N_CPLNT) {
    printf(" Inconsistent date file of techno.dat\n");
    exit(0);
  }
}




  int read_file()
{ FILE *fp;
  int i,j,k,n,idim,*id,jdim,*ids,idy,iflag;
  int **n_sk;
  double rdum,v;

  id=m_iarr1(N_SCEM);
  ids=m_iarr1(N_SCEM);

/**********************************
    control.dat
**********************************/
  n_sk=m_iarr2(N_SCEM,N_TIME);

  fp=fopen("control.dat","r");

  while(getc(fp)!=':');
  fscanf(fp," %d\n",&ictrl1); /* BAU or not */
  while(getc(fp)!=':');
  fscanf(fp," %d\n",&ictrl2); /* Carbon Tax */
  while(getc(fp)!=':');
  fscanf(fp," %d\n",&ictrl3); /* Carbon Emission Reg. */
  while(getc(fp)!=':');
  fscanf(fp," %d\n",&ictrl4); /* CO2 Concentration Reg. */
  while(getc(fp)!=':');
  fscanf(fp," %d\n",&ictrl9); /* Sulphur Tax */
  while(getc(fp)!=':');
  fscanf(fp," %d\n",&ictrl10); /* Sulphur Emission Reg. */
  while(getc(fp)!=':');
  fscanf(fp," %d\n",&ictrl11); /* Regional Temperature Change */
  while(getc(fp)!=':');
  fscanf(fp," %d\n",&ictrl5); /* Temperature Change Reg. */
  while(getc(fp)!=':');
  fscanf(fp," %d\n",&ictrl7); /* Damage Function */
  while(getc(fp)!=':');
  fscanf(fp," %d\n",&ictrl8); /* Macro Economic Model */
  while(getc(fp)!=':');
  fscanf(fp," %d\n",&ictrl6); /* Approximation */

  printf("\n");
  printf("  ============================================\n");
  if(ictrl1==1) printf("  Energy Demand adjustment by retail prices\n");
  if(ictrl2==1) printf("  Carbon Tax Policy \n");
  if(ictrl3==1) printf("  Emissions Regulation Policy \n");
  if(ictrl4==1) printf("  Concentration Regulation Policy \n");
  if(ictrl9==1)  printf("  Sulphur Tax Policy \n");
  if(ictrl10==1) printf("  Sulphur Emissions Regulation Policy \n");
  if(ictrl11==1) printf("  Regional Temperature Function \n");
  if(ictrl5==1) printf("  Temperature Regulation Policy \n");
  if(ictrl7==1) printf("  Damage Function \n");
  if(ictrl8==1) printf("  Integration of Macro Economic Model \n");
  if(ictrl6==1) printf("  Approximation mode \n");
  printf("  ============================================\n");

  idim=0;
  while(getc(fp)!=':');
  for(i=0;i<N_SCEM;i++) {
    fscanf(fp," %lf",&v);
    if(v>0.) {
      prob_s[idim]=v;
      id[idim]=i;
      idim++;
    }
  }

  N_SCE=idim;
  v=0.;
  for(i=0;i<N_SCE;i++) v+=prob_s[i];
  if(fabs(v-1.)>1.e-8) {
    printf("  Scenario Definitions of Probabilities are inappropriate!!\n");
    printf("  Please check the assumption about Scenario Branch\n");
    printf("  for decision making analysis in the file 'control.dat'!\n");
    exit(0);
  }

  jdim=0;
  for(j=0;j<N_BLKM;j++) {
    while(getc(fp)!=':');
    fscanf(fp," %d ",&idy);
    if(idy>=N_TIME) {
      printf("  Year Number should not be greater than %d.\n",N_TIME-1);
      printf("  Please check the assumption about Scenario Branch\n");
      printf("  for decision making analysis in the file 'control.dat'!\n");
      exit(0);
    }
    for(i=0;i<N_SCEM;i++) fscanf(fp," %d ",&ids[i]);
    iflag=0;
    for(i=0;i<N_SCE;i++)  iflag+=ids[id[i]];
    if(iflag!=0) {
      n_tm[jdim]=idy;
      for(i=0;i<N_SCE;i++) n_sc[i][jdim]=ids[id[i]];
      jdim++;
    }
  }
  N_BLK=jdim;

  N_TMP=0;
  for(i=0;i<N_BLK;i++)
    if(n_tm[i]>N_TMP) N_TMP=n_tm[i];
  N_TMP++;

  for(i=0;i<N_BLK;i++) {
     prob_k[i]=0.;
     for(j=0;j<N_SCE;j++)
        if(n_sc[j][i]==1) prob_k[i]+=prob_s[j];
     if(prob_k[i]>1.) {
       printf("  Probability Definitions are inapproreate!!\n");
       printf("  Please check the assumption about Scenario Branch\n");
       printf("  for decision making analysis in the file 'control.dat'!\n");
       exit(0);
     }
   }
  for(i=0;i<N_SCE;i++) {
    for(j=0;j<N_TMP;j++)
      n_sk[i][j]=-1;
    for(j=0;j<N_BLK;j++)
      if(n_sc[i][j]!=0) 
        if(n_sk[i][n_tm[j]]==-1) n_sk[i][n_tm[j]]=j;
        else {
          printf("  Double definitions\n");
          printf("  Scenario No.%d\n",i+1);
          printf("  Block    No.%d\n",j+1);
        printf("  Please check the assumption about Scenario Branch\n");
        printf("  for decision making analysis in the file 'control.dat'!\n");
          exit(0);
  }
  }

  for(j=0;j<N_TMP;j++)
    for(i=0;i<N_SCE;i++) 
      if(n_sk[i][j]==-1) {
        printf("  Incomplete definitions\n");
        printf("  Scenario No.%d\n",i+1);
        printf("  Year     No.%d\n",j);
        printf("  Please check the assumption about Scenario Branch\n");
        printf("  for decision making analysis in the file 'control.dat'!\n");
        exit(0);
      }


  printf("\n");
  printf("***********     Assumed Scenario Branches   **********\n");
  printf(" year  2010  2020  2030  2040  2050  2075  2100  2150 \n");
  printf("-----+-----+-----+-----+-----+-----+-----+-----+-----+\n");
  printf("\n");
  for(i=0;i<N_SCE;i++) {
    printf("     ");
    for(j=0;j<N_TMP;j++) printf("  %4d",n_sk[i][j]);
    printf("\n");
  }
  printf("\n");
  printf("******************************************************\n");
  printf("\n");

  for(i=0;i<N_SCE;i++)
    for(j=0;j<N_TMP;j++)
      if(j==0) {
        inc_mat[0][n_sk[i][j]]=-1;
        inc_mat[1][n_sk[i][j]]=-1;
      }
      else if(j==1) {
        inc_mat[0][n_sk[i][j]]=n_sk[i][j-1];
        inc_mat[1][n_sk[i][j]]=-1;
      }
      else {
        inc_mat[0][n_sk[i][j]]=n_sk[i][j-1];
        inc_mat[1][n_sk[i][j]]=n_sk[i][j-2];
      }

  for(i=0;i<N_SCEM;i++) 
    for(n=0;n<LR;n++)
      read_row(fp,co2tax[n][i],N_TIME);
  for(i=0;i<N_SCEM;i++) 
    for(n=0;n<LR;n++)
      read_row(fp,co2reg[n][i],N_TIME);
  for(i=0;i<N_SCEM;i++) 
    read_row(fp,co2con[i],N_TIME);
  for(i=0;i<N_SCEM;i++) 
    read_row(fp,temper[i],N_TIME);
  for(i=0;i<2;i++) 
    for(n=0;n<LR;n++)
      read_row(fp,co2tran[n][i],N_TIME);
  for(i=0;i<N_SCEM;i++)
    for(n=0;n<LR;n++)
      read_row(fp,sultax[n][i],N_TIME);
  for(i=0;i<N_SCEM;i++) 
    for(n=0;n<LR;n++)
      read_row(fp,sulreg[n][i],N_TIME);

  for(i=0;i<N_SCEM;i++) 
    read_row(fp,co2emi[i],N_TIME+1);

  for(i=0;i<N_SCEM;i++) 
    for(n=0;n<LR;n++)
      read_row(fp,soxemi[i][n],N_TIME+1);
  for(i=0;i<N_SCEM;i++)
    for(j=0;j<N_TIME+1;j++) {
      v=0.;
      for(n=0;n<LR;n++) v+=soxemi[i][n][j];
      tsoxemi[i][j]=v;
    }

  fclose(fp);

/**********************************
    techno.dat
**********************************/

  fp=fopen("techno.dat","r");

  for(i=0;i<N_FUEL;i++) {
    while(getc(fp)!=':');
    fscanf(fp," %lf\n",&co2cef[i]);
  }

  for(i=0;i<2;i++) {
    while(getc(fp)!=':');
    fscanf(fp," %lf\n",&sulcef[i]);
  }

  for(i=0;i<LR;i++) {
    while(getc(fp)!=':');
    fscanf(fp," %lf %lf %lf %lf\n",&shfdsk[i][0],&shfdsk[i][1],
    &shfdsk[i][2],&reoils[i]);
  }
   
  for(j=0;j<7;j++)
    for(i=0;i<LR;i++)
      rdcl_row(fp,&rdum,tdloss[i][j]);

  for(i=0;i<LR;i++)  read_row(fp,dulfel[i],3);
  for(i=0;i<LR;i++)  read_row(fp,parele[i],7);

  for(i=0;i<LR;i++)  rdcl_row(fp,&rdum,nclurt[i]);

  for(i=0;i<4;i++)   rdcl_row(fp,&rdum,trnlos[i]);

  for(i=0;i<N_EPLNT;i++) rdcl_row(fp,&ect_2000[i],elcoef[i]);

  for(i=0;i<3;i++)
    for(j=0;j<LR;j++) rdcl_row(fp,&rel_2000[i][j],relaef[i][j]);

  for(i=0;i<N_CPLNT;i++)
    for(j=0;j<3;j++) rdcl_row(fp,&rdum,chcoef[i][j]);

  for(i=0;i<3;i++)
    for(j=0;j<2;j++) rdcl_row(fp,&rdum,co2ene[i][j]);

  for(i=0;i<2;i++) {
    while(getc(fp)!=':');
    fscanf(fp," %lf\n",&co2sub[i]);
  }

  while(getc(fp)!=':');
  fscanf(fp," %lf\n",&co2upp);

  for(i=0;i<N_FOS;i++) {
    while(getc(fp)!=':');
    fscanf(fp," %lf\n",&upplmt[i]);
  }

  for(i=0;i<N_FOS+N_REN;i++) {
    while(getc(fp)!=':');
    fscanf(fp," %lf\n",&lowlmt[i]);
  }

  for(i=0;i<8;i++) {
    while(getc(fp)!=':');
    fscanf(fp," %lf\n",&deprrt[0][i]);
  }
  for(i=0;i<10;i++) {
    while(getc(fp)!=':');
    fscanf(fp," %lf\n",&deprrt[1][i]);
  }

  fclose(fp);

/**********************************
           cost.dat
**********************************/

  fp=fopen("cost.dat","r");

  for(i=0;i<6;i++) read_row(fp,trcost[i],3);
  for(i=6;i<9;i++) {
    while(getc(fp)!=':');
    fscanf(fp," %lf %lf\n",&trcost[i][0],&trcost[i][2]);
  }
  read_row(fp,trcost[9],3);
  for(i=0;i<N_PLNT;i++) read_row(fp,plcost[i],5);
  for(i=0;i<10;i++)
    for(j=0;j<LR;j++) read_row(fp,rlcost[i][j],N_TIME);
  for(i=0;i<N_FOS;i++)
    for(j=0;j<LR;j++) read_row(fp,egrade[j][i],N_EGRADE);
  for(i=0;i<N_FOS;i++) read_row(fp,epcost[i],N_EGRADE);
  for(i=0;i<N_FOS;i++) read_row(fp,rco2cef[i],N_EGRADE);
  for(i=0;i<N_REN-2;i++)
    for(j=0;j<LR;j++) read_row(fp,rgrade[j][i],6);
  for(k=0;k<LR;k++)
    for(i=0;i<N_REN-2;i++)
      for(j=0;j<N_RGRADE;j++)
        rgdk[k][i][j]=rgrade[k][i][0]*rgrade[k][i][j+1]/100.;
  for(j=0;j<LR;j++) read_row(fp,rgrade[j][2],1);
  for(i=0;i<N_REN-2;i++)
    for(j=0;j<LR;j++)
      read_row(fp,rpcost[j][i],6);
  for(j=0;j<LR;j++)
    read_row(fp,rpcost[j][2],1);
  for(i=0;i<N_REN;i++) read_row(fp,acrdrt[i],N_TIME);
  rdcl_row(fp,&rdum,nclrct);
  for(i=0;i<LR;i++) read_row(fp,co2cap[i],7);
  for(i=0;i<LR;i++) read_row(fp,co2cst[i],9);
  for(i=0;i<LR;i++) read_row(fp,refore[i],2+N_REFO*2);

  for(i=0;i<5;i++) read_row(fp,desulc[i],2);

  for(i=0;i<3;i++) {
    while(getc(fp)!=':');
    fscanf(fp," %lf\n",&desuld[i]);
  }

  fclose(fp);

/**********************************
           scenar.dat
**********************************/

  fp=fopen("scenar.dat","r");

  read_row(fp,discnt,N_TIME);

  for(i=0;i<4;i++) 
    for(j=0;j<LR;j++) 
      rdcl_row(fp,&dem_2000[j][i],demand[j][i]);
  for(i=0;i<LR;i++) rdcl_row(fp,&rdum,scnucl[i]);
  for(i=0;i<LR;i++) rdcl_row(fp,&rdum,misncl[i]);
  for(j=0;j<2;j++)
    for(i=0;i<LR;i++) 
      rdcl_row(fp,&rdum,oilsha[i][j]);

  for(i=0;i<LR;i++) {
    for(k=0;k<N_TIME;k++) {
      oilsha[i][2][k]=1.-oilsha[i][0][k]-oilsha[i][1][k];
      if(oilsha[i][2][k]<=0.) {
        printf(" Oil share data in scenar.dat are inappropreate.\n");
        printf(" Region No.%2d, for the stage of %d\n",i+1,k);
      }
    }
  }
  for(j=0;j<4;j++)
    for(i=0;i<LR;i++) 
      rdcl_row(fp,&ele_2000[i][j],ele_min[i][j]);
  for(i=0;i<LR;i++) rdcl_row(fp,&rdum,oilgenplt_max[i]);
  for(i=0;i<LR;i++) rdcl_row(fp,&rdum,sh_new_t[i]);
  fclose(fp);

/**********************************
           start.dat
**********************************/

  fp=fopen("start.dat","r");
  for(i=0;i<LR;i++) read_row(fp,prtrad[i],3);
  for(i=0;i<7;i++)
    for(j=0;j<LR;j++) read_row(fp,cexist[j][i],2);
  for(i=0;i<LR;i++) read_row(fp,currpr[i],5);
  fclose(fp);

/**********************************
           policy.dat
**********************************/

  fp=fopen("policy.dat","r");
  for(i=0;i<5;i++)
    for(j=0;j<LR;j++) read_row(fp,tariff[j][i],N_TIME);
  for(i=0;i<7;i++)
    for(j=0;j<LR;j++) read_row(fp,subsid[j][i],N_TIME);
  for(i=0;i<3;i++)
    for(j=0;j<LR;j++) read_row(fp,royalt[j][i],N_TIME);
  for(i=0;i<5;i++) 
    for(j=0;j<LR;j++) read_row(fp,profit[j][i],N_TIME);
  fclose(fp);

/**********************************
           trade.dat
**********************************/

  fp=fopen("trade.dat","r");
  for(i=0;i<LR;i++)
    for(j=0;j<LR;j++) {
      trland[i][j]=0.;
      trocea[i][j]=0.;
    }
  for(i=0;i<LR;i++) {
    while(getc(fp)!=':');
    for(j=0;j<LR;j++) fscanf(fp," %lf",&trland[i][j]);
  }
  for(i=0;i<LR;i++) {
    while(getc(fp)!=':');
    for(j=0;j<LR;j++) fscanf(fp," %lf",&trocea[i][j]);
  }
  for(i=0;i<LR;i++) read_row(fp,trnco2[i],3);
  fclose(fp);

/**********************************
           enecon.dat
**********************************/

  fp=fopen("enecon.dat","r");

  for(i=0;i<LR;i++) read_row(fp,enepri[i],4);
  for(i=0;i<LR;i++) read_row(fp,elast[i],4);
  for(i=0;i<LR;i++) read_row(fp,enepot[i],N_TIME);
  for(i=0;i<4;i++)
    for(n=0;n<LR;n++) read_row(fp,dispri[n][i],N_TIME);
  if(ictrl1==0) {
    for(n=0;n<LR;n++)
      for(k=0;k<N_TIME;k++)  enepot[n][k]=1.0;
    for(n=0;n<LR;n++)
      for(k=0;k<N_TIME;k++)
        for(i=0;i<N_DEM;i++)  dispri[n][i][k]=1.e5;
  }
  fclose(fp);

/**********************************
           shadow.dat
**********************************/

  for(n=0;n<LR;n++)
    for(i=0;i<N_DEM;i++) for(k=0;k<N_TIME;k++) shdpri[n][i][k]=0.;
  if((fp=fopen("shadow.dat","r"))!=NULL) {
    for(i=0;i<N_DEM;i++)
      for(n=0;n<LR;n++)
        read_row(fp,shdpri[n][i],N_TIME);
    fclose(fp);
    for(i=0;i<N_DEM;i++)
      for(n=0;n<LR;n++)
        for(k=0;k<N_TMP;k++)
          if(ictrl1==1&&fabs(shdpri[n][i][k])<1.e-4) {
            printf(" Please Check the file of 'shadow.dat'\n");
            exit(0);
    }
  }
  else if(ictrl1==1) {
    printf(" Please Check the file of 'shadow.dat'\n");
    exit(0);
  }

/**********************************
           maceco.dat
**********************************/

  fp=fopen("maceco.dat","r");
  for(n=0;n<LR;n++) read_row(fp,mepm[n],6);
  for(n=0;n<LR;n++) rdcl_row(fp,&rdum,pop0[n]);
  for(n=0;n<LR;n++) rdcl_row(fp,&gdp_2000[n],gdp0[n]);
  for(n=0;n<LR;n++) rdcl_row(fp,&ivs_2000[n],ivs0[n]);
  for(n=0;n<LR;n++) rdcl_row(fp,&rdum,kap_up[n]);
  for(n=0;n<LR;n++) rdcl_row(fp,&rdum,kap_low[n]);
  for(n=0;n<LR;n++) {
    gdp_2000[n]*=1.e3;
    for(i=0;i<N_TIME;i++) gdp0[n][i]*=1.e3;
  }
  if(ictrl1==0||ictrl8==0) {
    for(n=0;n<LR;n++)
      for(k=0;k<N_TIME;k++) {
  kap_up[n][k]=1.2;
        kap_low[n][k]=1.0;
      }
  }

  fclose(fp);

/**********************************
           biomass.dat
**********************************/

  fp=fopen("biomass.dat","r");
  for(n=0;n<LR;n++) rdcl_row(fp,&rdum,landarea[n]);
  for(i=0;i<2;i++)
    for(n=0;n<LR;n++) rdcl_row(fp,&rdum,bio_productivity[n][i]);
  for(i=0;i<12;i++)
    for(n=0;n<LR;n++) rdcl_row(fp,&rdum,bio_potential[n][i]);
  for(i=0;i<4;i++)
    for(n=0;n<LR;n++) read_row(fp,bio_share[n]+5*i,5);

  for(n=0;n<LR;n++) read_row(fp,bio_share[n]+20,4);
  for(i=0;i<4;i++)
    for(n=0;n<LR;n++) read_row(fp,bio_cost[n]+5*i,5);
  for(n=0;n<LR;n++) read_row(fp,bio_cost[n]+20,4);
  fclose(fp);
  return(1);
}


 double *m_darr1(i0)
 int i0;
{ double *mdar;
  mdar=(double *) malloc(i0*8);
  return(mdar);
}

 double **m_darr2(i0,j0)
 int i0,j0;
{ int i;
  double **mdar;
  mdar=(double **) malloc(i0*spd1);
  for(i=0;i<i0;i++) mdar[i]=m_darr1(j0);
  return(mdar);
}

 double ***m_darr3(i0,j0,k0)
 int i0,j0,k0;
{ int i;
  double ***mdar;
  mdar=(double ***) malloc(i0*spd2);
  for(i=0;i<i0;i++) mdar[i]=m_darr2(j0,k0);
  return(mdar);
}


 double ****m_darr4(i0,j0,k0,l0)
 int i0,j0,k0,l0;
{ int i;
  double ****mdar;
  mdar=(double ****) malloc(i0*spd3);
  for(i=0;i<i0;i++) mdar[i]=m_darr3(j0,k0,l0);
  return(mdar);
}


 int *m_iarr1(i0)
 int i0;
{ int *mdar;
  mdar=(int *) malloc(i0*sint);
  return(mdar);
}

 int **m_iarr2(i0,j0)
 int i0,j0;
{ int i;
  int **mdar;
  mdar=(int **) malloc(i0*spi1);
  for(i=0;i<i0;i++) mdar[i]=m_iarr1(j0);
  return(mdar);
}

 int ***m_iarr3(i0,j0,k0)
 int i0,j0,k0;
{ int i;
  int ***mdar;
  mdar=(int ***) malloc(i0*spi2);
  for(i=0;i<i0;i++) mdar[i]=m_iarr2(j0,k0);
  return(mdar);
}

 struct mat **m_marr1(i0)
 int i0;
{ int i;
  struct mat **mdar;
  mdar=(struct mat **) malloc(spm1*i0);
  for(i=0;i<i0;i++) mdar[i]=NULL;
  return(mdar);
}

 struct mat ***m_marr2(i0,j0)
 int i0,j0;
{ int i;
  struct mat ***mdar;
  mdar=(struct mat ***) malloc(spm2*i0);
  for(i=0;i<i0;i++) mdar[i]=m_marr1(j0);
  return(mdar);
}


  void read_row(fp,pt,i0)
  FILE *fp;
  int i0;
  double *pt;
{ int i;
  while(getc(fp)!=':');
  for(i=0;i<i0;i++) fscanf(fp," %lf",pt+i);
}

  void rdcl_row(fp,pt0,pt)
  FILE *fp;
  double *pt,*pt0;
{ while(getc(fp)!=':');
  fscanf(fp," %lf %lf %lf %lf %lf %lf %lf\n",pt0,
                                 pt,pt+2,pt+4,pt+5,pt+6,pt+7);
  *(pt+1)=(*(pt)+*(pt+2))*0.5;
  *(pt+3)=(*(pt+2)+*(pt+4))*0.5;
}


  void read_clima(emi,con,tem)
  double **emi,**con,**tem;
{ FILE *fp;
  double **temp,sum,v;
  int i,j,k,yr[11];

  temp=m_darr2(35,11);

  if((fp=fopen("clima.dat","r"))) {

/* Control Parameters */
     while(getc(fp)!=':'); fscanf(fp," %d\n",&ipch4);
     while(getc(fp)!=':'); fscanf(fp," %d\n",&iph2o);
     while(getc(fp)!=':'); fscanf(fp," %d\n",&ipo3);
     while(getc(fp)!=':'); fscanf(fp," %d\n",&ipso2);

/* Convergence Parameters*/
     while(getc(fp)!=':'); fscanf(fp," %lf %lf\n",&gain1,&gain2);
     while(getc(fp)!=':'); fscanf(fp," %lf %lf\n",&crite1,&crite2);
     while(getc(fp)!=':'); fscanf(fp," %d  %d\n",&nit1,&nit2);

/* Carbon Dioxide Model */
     read_val(fp,&cgtp);
     for(i=0;i<5;i++) {
       while(getc(fp)!=':');
       fscanf(fp," %lf %lf %lf\n",&ar[i],&ar[5+i],&ar[10+i]);
     }
     for(i=0;i<3;i++) {
       sum=ar[i*5]+ar[i*5+1]+ar[i*5+2]+ar[i*5+3]+ar[i*5+4];
       if(fabs(sum-1.0)> 1.e-8) {
         printf(" The sum of ARs is not equal to one!!\n");
         exit(0);
       }
     }
     for(i=0;i<5;i++) read_val(fp,&tr[i]);
     for(i=0;i<3;i++) read_val(fp,&ell[i]);
     for(i=0;i<6;i++) read_val(fp,&dee[i]);
     read_val(fp,&f80s);
     read_val(fp,&psi);
     read_val(fp,&plant0); read_val(fp,&detri0); read_val(fp,&soil0);
     read_val(fp,&gpp0);   read_val(fp,&res0);
     read_val(fp,&cmgp);   read_val(fp,&cmgh);   read_val(fp,&cmgs);
     sum=cmgp+cmgh+cmgs;
     if(fabs(sum-1.0)> 1.e-8) {
       printf(" The fraction sum of G is not equal to one!!\n");
       exit(0);
     }
     read_val(fp,&cpdm);   read_val(fp,&chdm);   read_val(fp,&csdm);
     sum=cpdm+chdm+csdm;
     if(fabs(sum-1.0)> 1.e-8) {
       printf(" The fraction sum of D is not equal to one!!\n");
       exit(0);
     }
     read_val(fp,&cplh);
     read_val(fp,&cpls);
     sum=cplh+cpls;
     if(fabs(sum-1.0)> 1.e-8) {
       printf(" The fraction sum of L is not equal to one!!\n");
       exit(0);
     }
     read_val(fp,&chqm);
     read_val(fp,&chqs);
     sum=chqm+chqs;
     if(fabs(sum-1.0)> 1.e-8) {
       printf(" The fraction sum of Q is not equal to one!!\n");
       exit(0);
     }
     read_val(fp,&ham);   read_val(fp,&hbs);   read_val(fp,&scm);
     read_val(fp,&d80s);
     read_val(fp,&rco2);  read_val(fp,&con0);  read_val(fp,&conb);
     read_val(fp,&fffrac);

/*  Methane Model */
     read_val(fp,&cmtb);   read_val(fp,&powch4a);  read_val(fp,&powch4);
     read_val(fp,&powno);  read_val(fp,&powco);    read_val(fp,&powvo);
     read_val(fp,&tau90);  read_val(fp,&tausoil);  read_val(fp,&ch4soc);
     read_val(fp,&vocsoc);

/*  Nitrous Oxide Model */
     read_val(fp,&cfn2o);  read_val(fp,&taun2o);

/*  Halocarbons Model */
     for(i=0;i<27;i++) {
       while(getc(fp)!=':');
       fscanf(fp," %lf %lf %lf %lf\n",
         &taucfc[i],&cfcfc[i],&rfcfc[i],&odpcfc[i]);
     }

/*  Radiative Forcing Model */
     for(i=0;i<8;i++) read_val(fp,&qcc[i]);
     for(i=0;i<5;i++) read_val(fp,&ovlap[i]);
     while(getc(fp)!=':'); fscanf(fp," %d",&lag);
     read_val(fp,&expcl);  read_val(fp,&talstk);
     read_val(fp,&aso2);   read_val(fp,&bso2);
     read_val(fp,&cso2);   read_val(fp,&enat);

/* Temperature Rise Model */
     while(getc(fp)!=':');
     fscanf(fp," %lf %lf %lf\n",&fhemd[0],&fhemi[0],&fhemo[0]);
     while(getc(fp)!=':');
     fscanf(fp," %lf %lf %lf\n",&fhemd[1],&fhemi[1],&fhemo[1]);
     while(getc(fp)!=':');
     fscanf(fp," %lf %lf %lf\n",&flod[0],&floi[0],&floo[0]);
     while(getc(fp)!=':');
     fscanf(fp," %lf %lf %lf\n",&flod[1],&floi[1],&floo[1]);

     read_val(fp,&fland[0]);   read_val(fp,&fland[1]);
     read_val(fp,&t2x);        read_val(fp,&rho);
     read_val(fp,&specht);     read_val(fp,&hm);
     read_val(fp,&yk);         read_val(fp,&psink);
     read_val(fp,&paiup);      read_val(fp,&thtmp);
     read_val(fp,&xlamr);      read_val(fp,&xklo);
     read_val(fp,&xkns);
     while(getc(fp)!=':'); fscanf(fp," %d\n",&ntp);
     while(getc(fp)!=':'); fscanf(fp," %d\n",&nbox);
     read_val(fp,&dz);         read_val(fp,&betai);
     read_val(fp,&taui);       read_val(fp,&zi0);
     read_val(fp,&betag);      read_val(fp,&beta1);
     read_val(fp,&beta2);      read_val(fp,&db3);

/* Future Emissions Scenarios */
     while(getc(fp)!=':');
     for(i=0;i<11;i++) fscanf(fp, " %d",&yr[i]);
     for(j=0;j<35;j++) {
       while(getc(fp)!=':');
       for(i=0;i<11;i++) fscanf(fp, " %lf",&temp[j][i]);
     }
     for(i=0;i<35;i++) {
       for(j=225;j<yr[10]-1764;j++) emi[i][j]=0.;
       interpolate(11,yr,temp[i],emi[i]);
     }


/* Historical Concentrations of CFCs */

     for(j=icfc;j<27+icfc;j++) {
       for(i=0;i<186;i++) con[j][i]=0.;
       while(getc(fp)!=':');
         fscanf(fp," %lf",&con[j][185]);
         for(i=190;i<226;i+=5) {
           fscanf(fp," %lf",&con[j][i]);
           v=(con[j][i]-con[j][i-5])/5.;
           for(k=1;k<5;k++) con[j][i-5+k]=con[j][i-5]+v*k;
   }
     }


/* Historical Data on Industrial Emissions, CO2,CH4,N2O Concentrations,
   and Temeperature Rises */

     for(i=0;i<226;i++) {
       while(getc(fp)!=':');
       fscanf(fp,"%lf %lf %lf %lf %lf %lf %lf\n",
       con[ico2i]+i,emi[ico2i]+i,con[ich4]+i,con[in2o]+i,emi[isox]+i,
       tem[5]+i,tem[6]+i);
     }

/* Coefficients for Regional Temperature Change */
     while(getc(fp)!=':');
     for(i=0;i<LR;i++) fscanf(fp," %lf",&rtmpc[i]);
     for(i=0;i<LR;i++) {
       while(getc(fp)!=':');
       for(j=0;j<LR;j++) fscanf(fp," %lf",&rtmps[i][j]);
     }

     fclose(fp);
  }
  else {
    printf("  clima.dat : No such a file!!\n"); 
    exit(0);
  }
}


  void read_val(fp,pt)
  FILE *fp;
  double *pt;
{ while(getc(fp)!=':'); fscanf(fp," %lf",pt);}



  void write_data()
{ int i,j,k,n;
  FILE *fp;
/*

  fp=fopen("c_data.dat","w");
  fprintf(fp,"*********************************************\n");
  fprintf(fp,"                 control.dat\n");
  fprintf(fp,"*********************************************\n");
  fprintf(fp,"\n");
  fprintf(fp," ICTRL1     %d \n",ictrl1);
  fprintf(fp," ICTRL2     %d \n",ictrl2);
  fprintf(fp," ICTRL3     %d \n",ictrl3);
  fprintf(fp," ICTRL4     %d \n",ictrl4);
  fprintf(fp," ICTRL5     %d \n",ictrl5);
  fprintf(fp," ICTRL6     %d \n",ictrl6);
  fprintf(fp," ICTRL7     %d \n",ictrl7);
  fprintf(fp," PROB_S \n");
  for(i=0;i<N_SCE;i++)
    fprintf(fp," %8.5f",prob_s[i]);
  fprintf(fp,"\n");
  fprintf(fp," N_TM      N_SC \n");
  for(i=0;i<N_BLK;i++) {
    fprintf(fp," %3d    ",n_tm[i]);
    for(j=0;j<N_SCE;j++)
      fprintf(fp," %3d ",n_sc[j][i]);
    fprintf(fp,"\n");
  }

  fprintf(fp," CO2TAX \n");
  for(i=0;i<N_SCEM;i++) {
    fprintf(fp," scenario No.%d\n",i+1);
    for(n=0;n<LR;n++) {
      for(j=0;j<N_TIME;j++) fprintf(fp," %8.1f",co2tax[n][i][j]);
      fprintf(fp,"\n");
        }
  }
  fprintf(fp," CO2REG \n");
  for(i=0;i<N_SCEM;i++) {
    fprintf(fp," scenario No.%d\n",i+1);
    for(n=0;n<LR;n++) {
      for(j=0;j<N_TIME;j++) fprintf(fp," %8.1f",co2reg[n][i][j]);
      fprintf(fp,"\n");
        }
  }
  fprintf(fp," CO2CON \n");
  for(i=0;i<N_SCEM;i++) {
    fprintf(fp," scenario No.%d\n",i+1);
    for(j=0;j<N_TIME;j++) fprintf(fp," %8.1f",co2con[i][j]);
    fprintf(fp,"\n");
  }
  fprintf(fp," TEMPER \n");
  for(i=0;i<N_SCEM;i++) {
    fprintf(fp," scenario No.%d\n",i+1);
    for(j=0;j<N_TIME;j++) fprintf(fp," %8.1f",temper[i][j]);
    fprintf(fp,"\n");
  }
  fprintf(fp," CO2EMI \n");
  for(i=0;i<N_SCEM;i++) {
    fprintf(fp," scenario No.%d\n",i+1);
    for(j=0;j<N_TIME+1;j++) fprintf(fp," %6.2f",co2emi[i][j]);
    fprintf(fp,"\n");
  }
  fprintf(fp,"\n");

  
  fprintf(fp,"*********************************************\n");
  fprintf(fp,"                  techno.dat\n");
  fprintf(fp,"*********************************************\n");
  fprintf(fp,"\n");
  fprintf(fp," CO2CEF \n");
  for(i=0;i<N_FUEL;i++) fprintf(fp," %8.3f",co2cef[i]);
  fprintf(fp,"\n");
  fprintf(fp," SHFDSK \n");
  for(i=0;i<LR;i++) {
    for(j=0;j<3;j++) fprintf(fp," %8.3f",shfdsk[i][j]);
    fprintf(fp,"\n");
      }
  fprintf(fp," REOILS \n");
  for(i=0;i<LR;i++) fprintf(fp," %8.3f\n",reoils[i]);
  fprintf(fp," TDLOSS \n");
  for(j=0;j<7;j++) {
    fprintf(fp," tdloss No.%d\n",j);
    for(i=0;i<LR;i++) {
      for(k=0;k<N_TIME;k++) fprintf(fp," %8.3f",tdloss[i][j][k]);
      fprintf(fp,"\n");
    }
  }
  fprintf(fp," DULFEL \n");
  for(i=0;i<LR;i++) {
    for(j=0;j<3;j++) fprintf(fp," %8.3f",dulfel[i][j]);
    fprintf(fp,"\n");
      }
  fprintf(fp," PARELE \n");
  for(i=0;i<LR;i++) {
    for(j=0;j<7;j++) fprintf(fp," %8.3f",parele[i][j]);
    fprintf(fp,"\n");
      }
  fprintf(fp," NCLURT \n");
  for(i=0;i<LR;i++) {
    for(j=0;j<N_TIME;j++) fprintf(fp," %8.3f",nclurt[i][j]);
    fprintf(fp,"\n");
      }
  fprintf(fp," TRNLOS \n");
  for(i=0;i<4;i++) {
    for(j=0;j<N_TIME;j++) fprintf(fp," %8.3f",trnlos[i][j]);
    fprintf(fp,"\n");
      }
  fprintf(fp," ELCOEF \n");
  for(i=0;i<N_EPLNT;i++) {
    fprintf(fp," plant No.%d\n",i);
      for(k=0;k<N_TIME;k++) fprintf(fp," %8.3f",elcoef[i][k]);
    fprintf(fp,"\n");
  }
  fprintf(fp," RELAEF \n");
  for(i=0;i<LR;i++) {
    for(j=0;j<N_TIME;j++) fprintf(fp," %8.3f",relaef[i][j]);
    fprintf(fp,"\n");
      }

  fprintf(fp," CHCOEF \n");
  for(i=0;i<N_CPLNT;i++) {
    fprintf(fp," plant No.%d\n",i);
    for(j=0;j<3;j++) {
      for(k=0;k<N_TIME;k++) fprintf(fp," %8.3f",chcoef[i][j][k]);
    fprintf(fp,"\n");
    }
  }
  fprintf(fp," CO2ENE \n");
  for(i=0;i<3;i++) {
    fprintf(fp," process No.%d\n",i);
    for(j=0;j<2;j++) {
      for(k=0;k<N_TIME;k++) fprintf(fp," %8.3f",co2ene[i][j][k]);
    fprintf(fp,"\n");
    }
  }
  fprintf(fp," CO2SUB \n");
  fprintf(fp," %8.3f %8.3f\n",co2sub[0],co2sub[1]);
  fprintf(fp," CO2UPP \n");
  fprintf(fp," %8.3f\n",co2upp);
  fprintf(fp," UPPLMT \n");
  for(j=0;j<N_FOS;j++) 
    fprintf(fp," %8.3f\n",upplmt[j]);
  fprintf(fp," LOWLMT \n");
  for(j=0;j<N_FOS+N_REN;j++)
    fprintf(fp," %8.3f\n",lowlmt[j]);
  fprintf(fp," DEPRRT \n");
  for(j=0;j<8;j++)
    fprintf(fp," %8.3f\n",deprrt[0][j]);
  fprintf(fp,"\n");
  for(j=0;j<10;j++)
    fprintf(fp," %8.3f\n",deprrt[1][j]);

  fprintf(fp,"\n");
  fprintf(fp,"*********************************************\n");
  fprintf(fp,"                    cost.dat\n");
  fprintf(fp,"*********************************************\n");
  fprintf(fp,"\n");

  fprintf(fp," TRCOST\n");
  for(i=0;i<10;i++)
    fprintf(fp," %12.3f %12.3f %12.3f\n",trcost[i][0],trcost[i][1],
    trcost[i][2]);
  fprintf(fp," PLCOST\n");
  for(i=0;i<N_PLNT;i++)
    fprintf(fp," %12.3f %12.3f %12.3f %12.3f\n",plcost[i][0],plcost[i][1],
    plcost[i][2],plcost[i][3],plcost[i][4]);
  fprintf(fp,"RLCOST\n");
  for(i=0;i<2;i++) {
    fprintf(fp," rlcost no.%d\n",i);
    for(n=0;n<LR;n++) {
      for(j=0;j<N_TIME;j++) fprintf(fp," %8.3f",rlcost[i][n][j]);
      fprintf(fp,"\n");
    }
  }
    
  fprintf(fp," EGRADE\n");
  for(i=0;i<N_FOS;i++){
    fprintf(fp," resource No.%d\n",i);
    for(j=0;j<LR;j++) {
      for(k=0;k<N_GRADE;k++) fprintf(fp," %10.3f",egrade[j][i][k]);
    fprintf(fp,"\n");
    }
  }
  fprintf(fp," EPCOST\n");
  for(i=0;i<N_FOS;i++){
    fprintf(fp," resource No.%d\n",i);
    for(k=0;k<N_GRADE;k++) fprintf(fp," %10.3f",epcost[i][k]);
    fprintf(fp,"\n");
  }
  fprintf(fp," RGRADE\n");
  for(i=0;i<4;i++){
    fprintf(fp," resource No.%d\n",i);
    for(j=0;j<LR;j++) {
      for(k=0;k<6;k++) fprintf(fp," %10.3f",rgrade[j][i][k]);
    fprintf(fp,"\n");
    }
  }
  fprintf(fp," RPCOST\n");
  for(i=0;i<4;i++){
    fprintf(fp," resource No.%d\n",i);
    for(j=0;j<LR;j++) {
      for(k=0;k<6;k++) fprintf(fp," %10.3f",rpcost[j][i][k]);
    fprintf(fp,"\n");
    }
  }

  fprintf(fp," ACRDRT\n");
  for(i=0;i<4;i++) {
    fprintf(fp," acrdrt No.%d\n",i);
    for(j=0;j<N_TIME;j++) fprintf(fp," %8.3f",acrdrt[i][j]);
    fprintf(fp,"\n");
  }
  fprintf(fp," NCLRCT \n");
  for(i=0;i<N_TIME;i++) fprintf(fp," %8.3f",nclrct[i]);
  fprintf(fp,"\n");
  fprintf(fp," CO2CAP \n");
  for(i=0;i<LR;i++) {
    for(j=0;j<N_DCO2-2;j++) fprintf(fp," %8.3f",co2cap[i][j]);
    fprintf(fp,"\n");
      }
  fprintf(fp," CO2CST \n");
  for(i=0;i<LR;i++) {
    for(j=0;j<N_DCO2;j++) fprintf(fp," %8.3f",co2cst[i][j]);
    fprintf(fp,"\n");
      }
  fprintf(fp," REFORE \n");
  for(i=0;i<LR;i++) {
    for(j=0;j<2+N_REFO*2;j++) fprintf(fp," %8.3f",refore[i][j]);
    fprintf(fp,"\n");
  }
  fprintf(fp,"\n");

  fprintf(fp,"*********************************************\n");
  fprintf(fp,"                  scenar.dat\n");
  fprintf(fp,"*********************************************\n");
  fprintf(fp,"\n");
  fprintf(fp," DISCOUNT\n");
  for(i=0;i<N_TIME;i++) 
    fprintf(fp," %7.4f",discnt[i]);
  fprintf(fp,"\n");
  fprintf(fp," DEMAND\n");
  for(i=0;i<4;i++){
    fprintf(fp," demand No.%d\n",i);
    for(j=0;j<LR;j++) {
      fprintf(fp," %7.2f",dem_2000[j][i]);
      for(k=0;k<N_TIME;k++) fprintf(fp," %7.2f",demand[j][i][k]);
    fprintf(fp,"\n");
    }
  }
  fprintf(fp," SCNUCL \n");
  for(i=0;i<LR;i++) {
    for(j=0;j<N_TIME;j++) fprintf(fp," %8.3f",scnucl[i][j]);
    fprintf(fp,"\n");
  }
  fprintf(fp," MISNCL \n");
  for(i=0;i<LR;i++) {
    for(j=0;j<N_TIME;j++) fprintf(fp," %8.3f",misncl[i][j]);
    fprintf(fp,"\n");
  }
  fprintf(fp," OILSHA\n");
  for(i=0;i<2;i++){
    fprintf(fp," oil product No.%d\n",i);
    for(j=0;j<LR;j++) {
      for(k=0;k<N_TIME;k++) fprintf(fp," %8.3f",oilsha[j][i][k]);
    fprintf(fp,"\n");
    }
  }
  fprintf(fp," ELE_2000 and ELE_MIN\n");
  for(i=0;i<4;i++){
    fprintf(fp," electricity generated No.%d\n",i);
    for(j=0;j<LR;j++) {
      fprintf(fp," %7.2f",ele_2000[j][i]);
      for(k=0;k<N_TIME;k++) fprintf(fp," %7.2f",ele_min[j][i][k]);
    fprintf(fp,"\n");
    }
  }
  fprintf(fp," POP0 \n");
  for(i=0;i<LR;i++) {
    for(j=0;j<N_TIME;j++) fprintf(fp," %8.3f",pop0[i][j]);
    fprintf(fp,"\n");
  }
  fprintf(fp," GDP0 \n");
  for(i=0;i<LR;i++) {
    for(j=0;j<N_TIME;j++) fprintf(fp," %8.2f",gdp0[i][j]);
    fprintf(fp,"\n");
  }
  fprintf(fp," SH_NEW_T \n");
  for(i=0;i<LR;i++) {
    for(j=0;j<N_TIME;j++) fprintf(fp," %8.2f",sh_new_t[i][j]);
    fprintf(fp,"\n");
  }

  fprintf(fp,"\n");
  fprintf(fp,"*********************************************\n");
  fprintf(fp,"                  policy.dat\n");
  fprintf(fp,"*********************************************\n");
  fprintf(fp,"\n");
  fprintf(fp," TARIFF\n");
  for(i=0;i<5;i++){
    fprintf(fp," tariff No.%d\n",i);
    for(j=0;j<LR;j++) {
      for(k=0;k<N_TIME;k++) fprintf(fp," %8.1f",tariff[j][i][k]);
    fprintf(fp,"\n");
    }
  }
  fprintf(fp," SUBSID\n");
  for(i=0;i<7;i++){
    fprintf(fp," subsidy No.%d\n",i);
    for(j=0;j<LR;j++) {
      for(k=0;k<N_TIME;k++) fprintf(fp," %8.1f",subsid[j][i][k]);
    fprintf(fp,"\n");
    }
  }
  fprintf(fp," ROYALT\n");
  for(i=0;i<3;i++){
    fprintf(fp," royalty No.%d\n",i);
    for(j=0;j<LR;j++) {
      for(k=0;k<N_TIME;k++) fprintf(fp," %8.1f",royalt[j][i][k]);
    fprintf(fp,"\n");
    }
  }
  fprintf(fp," PROFIT\n");
  for(i=0;i<5;i++){
    fprintf(fp," profit No.%d\n",i);
    for(j=0;j<LR;j++) {
      for(k=0;k<N_TIME;k++) fprintf(fp," %8.1f",profit[j][i][k]);
    fprintf(fp,"\n");
    }
  }
  fprintf(fp,"\n");
  fprintf(fp,"*********************************************\n");
  fprintf(fp,"                  trade.dat\n");
  fprintf(fp,"*********************************************\n");
  fprintf(fp,"\n");
  fprintf(fp," TRLAND \n");
  for(i=0;i<LR;i++) {
    for(j=0;j<LR;j++) fprintf(fp," %6.1f",trland[i][j]);
    fprintf(fp,"\n");
      }
  fprintf(fp," TROCEA \n");
  for(i=0;i<LR;i++) {
    for(j=0;j<LR;j++) fprintf(fp," %6.1f",trocea[i][j]);
    fprintf(fp,"\n");
      }
  fprintf(fp," TRNCO2 \n");
  for(i=0;i<LR;i++) {
    for(j=0;j<3;j++) fprintf(fp," %6.1f",trnco2[i][j]);
    fprintf(fp,"\n");
      }
  fprintf(fp,"\n");
  fprintf(fp,"*********************************************\n");
  fprintf(fp,"                  start.dat\n");
  fprintf(fp,"*********************************************\n");
  fprintf(fp,"\n");
  fprintf(fp," PRTRAD \n");
  for(i=0;i<LR;i++) {
    for(j=0;j<3;j++) fprintf(fp," %8.3f",prtrad[i][j]);
    fprintf(fp,"\n");
  }
  fprintf(fp," CEXIST\n");
  for(i=0;i<7;i++){
    fprintf(fp," plant No.%d\n",i);
    for(j=0;j<LR;j++) {
      for(k=0;k<2;k++) fprintf(fp," %10.3f",cexist[j][i][k]);
    fprintf(fp,"\n");
    }
  }
  fprintf(fp," CURRPR \n");
  for(i=0;i<LR;i++) {
    for(j=0;j<6;j++) fprintf(fp," %8.3f",currpr[i][j]);
    fprintf(fp,"\n");
  }
  fprintf(fp,"\n");
  fprintf(fp,"*********************************************\n");
  fprintf(fp,"                  enecon.dat\n");
  fprintf(fp,"*********************************************\n");
  fprintf(fp,"\n");
  fprintf(fp," ENEPRI\n");
  for(i=0;i<LR;i++) {
    for(j=0;j<4;j++) fprintf(fp," %10.3f",enepri[i][j]);
  fprintf(fp,"\n");
  }
  fprintf(fp," ELAST\n");
  for(i=0;i<LR;i++) {
    for(j=0;j<4;j++) fprintf(fp," %10.3f",elast[i][j]);
  fprintf(fp,"\n");
  }
  fprintf(fp," ENEPOT\n");
  for(i=0;i<LR;i++) {
    for(j=0;j<N_TIME;j++) fprintf(fp," %8.3f",enepot[i][j]);
  fprintf(fp,"\n");
  }
  fprintf(fp," DISPRI\n");
  for(i=0;i<4;i++){
    fprintf(fp," dispri No.%d\n",i);
    for(j=0;j<LR;j++) {
      for(k=0;k<N_TIME;k++) fprintf(fp," %8.2f",dispri[j][i][k]);
    fprintf(fp,"\n");
    }
  }
  fclose(fp);
*/
}

